------------------------------------------------------------------------------------------------------------------------------------------------------
--                                           Captulo 06 Laboratrio - Reportando dados de multiplas tabelas                                        --
--                                               Treinamento para certificao Fundamentals SQL Oracle                                              --
--                                           Pedro F. Carvalho - DBA / Analista de Sistemas / Desenvolvedor                                         --
--                                         Site : www.pedrofcarvalho.com.br   E-mail : contato@pedrofcarvalho.com.br                                --
------------------------------------------------------------------------------------------------------------------------------------------------------

/* Exerccio 01
O departamento de RH precisa de uma consulta que solicite ao usurio um sobrenome de empregado.
A consulta, em seguida, exibe o sobrenome e a data de contratao de qualquer funcionrio no mesma
departamento como o empregado cujo nome eles fornecem (excluindo esse empregado). Para
Exemplo, se o usurio entrar Zlotkey, localizar todos os funcionrios que trabalham com Zlotkey
(Excluindo Zlotkey).
*/

select last_name, hire_date
from employees
where department_id = ( select department_id
                        from employees
                        where last_name = '&&Nome')
and last_name <> '&Nome';

/* Exerccio 02
Crie um relatrio que exiba o nmero de empregado, sobrenome e salrio de todos
empregados que ganham mais do que o salrio mdio. Classifique os resultados por ordem de
salrio ascendente.
*/

select employee_id, last_name, salary
from employees
where salary > (select avg(salary)
                from employees)
order by salary;

/* Exerccio 03
Escreva uma consulta que exibe o nmero de empregado e o sobrenome de todos os funcionrios que
trabalhe em um departamento com qualquer funcionrio cujo sobrenome contenha um "u".
*/

select employee_id, last_name
from employees
where department_id in (select department_id
                         from employees
                        where last_name like '%u%');


/* Exerccio 04
O departamento de RH precisa de um relatrio que exibe o sobrenome, o nmero do departamento,
e ID do trabalho de todos os funcionrios cujo ID de localizao do departamento  1700.
Modificar a consulta para que o usurio  solicitado para um local ID. 
*/

select last_name, department_id, job_id
from employees
where department_id in (select department_id
                        from departments
                        where location_id = 1700);
                        
select last_name, department_id, job_id
from employees
where department_id in (select department_id
                        from departments
                        where location_id = '&local');
                        

/* Exerccio 05
Criar um relatrio para HR que exibe o sobrenome e o salrio de cada funcionrio que
 reportado ao KING
*/

select last_name, salary
from employees
where manager_id in (select employee_id
                    from employees
                    where last_name = 'King');



/* Exerccio 06
Crie um relatrio para HR que exibe o nmero de departamento, sobrenome e ID do trabalho para
Cada funcionrio do departamento Executivo.
*/

select department_id, last_name, job_id
from employees
where department_id in (select department_id
                        from departments
                        where department_name = 'Executive');
                        

/* Exerccio 07
Crie um relatrio que exiba uma lista de todos os funcionrios cujo salrio  maior
salrio de qualquer funcionrio do departamento 60.
*/

select last_name, salary
from employees
where salary > any (select salary
                    from employees
                    where department_id = 60);
                    
/* Exerccio 08
Modifique a consulta anterior para exibir o nmero de empregado, sobrenome,
e salrio de todos os empregados que ganham mais do que o salrio mdio e que trabalham em um
departamento com qualquer funcionrio cujo sobrenome contenha um "u".
*/

select last_name, salary
from employees
where department_id in (select department_id
                       from employees
                       where last_name like '%u%')
and salary >          (select avg(salary) from employees);

-- Passos de estudos
-- 1 - Assistir a video aula somente observando 1x
-- 2 - Assistir a video aula agora fazendo os scritps 1x
-- 3 - Assistir a video aula de laboratrio 1x
-- 4 - Assistir a video aula de laboratrio fazendo os scritps 1x
-- 5 - Realizar o simulado online
       
-- Abraos e bons estudos !
       






